import board, time, neopixel, pwmio, digitalio,adafruit_vl53l1x, math, touchio
from audiomp3 import MP3Decoder
try:
    from audioio import AudioOut
except ImportError:
    try:
        from audiopwmio import PWMAudioOut as AudioOut
    except ImportError:
        pass  # not always supported by every board!

i2c = board.I2C()
distance_sensor = adafruit_vl53l1x.VL53L1X(i2c)
distance_sensor.distance_mode = 1
distance_sensor.timing_budget = 100

distance_sensor.start_ranging()

strip_pin = board.A1
strip_num_of_lights = 30
strip = neopixel.NeoPixel(strip_pin, strip_num_of_lights)

strip2_pin = board.A2
strip2_num_of_lights = 30
strip2 = neopixel.NeoPixel(strip2_pin, strip2_num_of_lights)

startSecs = 57
startMins = 59
startHrs = 8

firstRun = True

currentSecs = 0
currentMins = 0
currentHrs = 0

PM = False

hrTimes = ["1.mp3","2.mp3","3.mp3","4.mp3","5.mp3","6.mp3","7.mp3","8.mp3","9.mp3","10.mp3","11.mp3","12.mp3"]
minTimes = ["oclock.mp3","1.mp3","2.mp3","3.mp3","4.mp3","5.mp3","6.mp3","7.mp3","8.mp3","9.mp3","10.mp3","11.mp3","12.mp3","13.mp3","14.mp3","15.mp3","16.mp3","17.mp3",
"18.mp3","19.mp3","20.mp3","21.mp3","22.mp3","23.mp3","24.mp3","25.mp3","26.mp3","27.mp3","28.mp3","29.mp3","30.mp3","31.mp3","32.mp3","33.mp3","34.mp3","35.mp3","36.mp3",
"37.mp3","38.mp3","39.mp3","40.mp3","41.mp3","42.mp3","43.mp3","44.mp3","45.mp3","46.mp3","47.mp3","48.mp3","49.mp3","50.mp3","51.mp3","52.mp3","53.mp3","54.mp3","55.mp3",
"56.mp3","57.mp3","58.mp3","59.mp3"]

mp3 = open(hrTimes[0], "rb")
decoder = MP3Decoder(mp3)
speaker = digitalio.DigitalInOut(board.SPEAKER_ENABLE)
speaker.direction = digitalio.Direction.OUTPUT
speaker.value = True
audio = AudioOut(board.SPEAKER)

alarmHrs = 9
alarmMins = 0
alarmSecs = 0
alarmTime = "AM"

def play_sound (filename):
    decoder.file = open(filename, "rb")
    audio.play(decoder)
    while audio.playing:
        pass

while True:
    #If first cycle, set time as start time and print starting time
    if firstRun == True:
        currentSecs = startSecs
        currentMins = startMins
        currentHrs = startHrs
        firstRun = False
        print("Starting Time: " + str(currentSecs) + " secs, " + str(currentMins) + " mins, " + str(currentHrs)+ " Hrs")

    #Main clock cycle
    time.sleep(1)
    strip.fill((0,0,0))
    strip2.fill((0,0,0))
    upCount = 1
    if currentHrs == alarmHrs and currentMins == alarmMins and currentSecs == alarmSecs:
        if (alarmTime == "AM" and PM == False) or (alarmTime == "PM" and PM == True):
            strip.fill((255,0,0))
            strip2.fill((255,0,0))
            play_sound("scream.mp3")
            print("Alarm!")
            upCount+=1
            strip.fill((0,0,0))
            strip2.fill((0,0,0))
    currentSecs += 1
    if currentSecs >= 60:
        currentMins += 1
        currentSecs -= 60
    if currentMins >= 60:
        currentHrs += 1
        currentMins -= 60
    if currentHrs >= 13:
        currentHrs -= 12
        if PM == False:
            PM = True
        else:
            PM = False

    #Set pixels to light up
    if currentHrs == 12:
        hrPixel = 0
    else:
        hrPixel = (currentHrs)*5
    minPixel = currentMins
    secPixel = currentSecs

    #Light up each given pixel
    if hrPixel == secPixel == minPixel:
        if secPixel <30:
            strip[secPixel] = (255,255,255)
        else:
            strip2[secPixel-30] = (255,255,255)
    elif hrPixel == secPixel:
        if secPixel < 30:
            strip[secPixel] = (255,0,255)
        else:
            strip2[secPixel-30] = (255,0,255)
        if minPixel < 30:
            strip[minPixel] = (0,255,0)
        else:
            strip2[minPixel-30] = (0,255,0)
    elif hrPixel == minPixel:
        if minPixel < 30:
            strip[minPixel] = (255,255,0)
        else:
            strip2[minPixel-30] = (255,255,0)
        if secPixel < 30:
            strip[secPixel] = (0,0,255)
        else:
            strip2[secPixel-30] = (0,0,255)
    elif secPixel == minPixel:
        if secPixel < 30:
            strip[secPixel] = (0,255,255)
        else:
            strip2[secPixel-30] = (0,255,255)
        if hrPixel < 30:
            strip[hrPixel] = (255,0,0)
        else:
            strip2[hrPixel-30] = (255,0,0)
    else:
        if secPixel < 30:
            strip[secPixel] = (0,0,255)
        else:
            strip2[secPixel-30] = (0,0,255)
        if minPixel < 30:
            strip[minPixel] = (0,255,0)
        else:
            strip2[minPixel-30] = (0,255,0)
        if hrPixel < 30:
            strip[hrPixel] = (255,0,0)
        else:
            strip2[hrPixel-30] = (255,0,0)

    #Print the current time
    print(str(currentSecs) + " secs, " + str(currentMins) + " mins, " + str(currentHrs)+ " hrs")
    if PM == True:
        print("PM")
    else:
        print("AM")

    #Announce the current time if the distance sensor has a reading and the lights are enabled
    if distance_sensor.data_ready:
        distance = distance_sensor.distance
        if distance == None:
            distance = 0
        if distance == 0:
            continue
        play_sound("its.mp3")
        play_sound(hrTimes[currentHrs-1])
        play_sound(minTimes[currentMins])
        if PM == True:
            play_sound("PM.mp3")#PM Sound
        else:
            play_sound("AM.mp3")#AM Sound
        currentSecs += 3
        if currentSecs >= 60:
            currentMins += 1
            currentSecs -= 60
        if currentMins >= 60:
            currentHrs += 1
            currentMins -= 60
        if currentHrs >= 13:
            currentHrs -= 12
            if PM == False:
                PM = True
            else:
                PM = False

